package juliac.generated;

import org.objectweb.fractal.julia.control.lifecycle.ChainedIllegalLifeCycleException;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.julia.ComponentInterface;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import org.objectweb.fractal.koch.control.interceptor.IllegalInterceptorException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.julia.Interceptor;
import org.objectweb.fractal.koch.control.interceptor.InterceptorController;
import org.objectweb.fractal.koch.control.interceptor.InterceptorDefAttributes;
import org.objectweb.fractal.api.control.LifeCycleController;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin
 * @see org.objectweb.fractal.koch.control.interceptor.LifeCycleInterceptorMixin
 */
public class InterceptorControllerImpl implements Controller , Generated , InterceptorController , InterceptorDefAttributes {
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(InitializationContext ic) throws InstantiationException {
        initFcController$1(ic);
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * Does nothing.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * The {@link LifeCycleController} interface of the component to which this
     * controller object belongs.
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#weaveableOptLC
     */
    public LifeCycleController weaveableOptLC;
    
    /** 
     * Checks that the component is stopped and then calls the overriden method.

     *

     * @param itf          the Fractal interface

     * @param interceptor  the interceptor

     * 

     * @throws IllegalLifeCycleException if this component has a {@link

     *      LifeCycleController} interface, but it is not in an appropriate

     *      state to perform this operation.

     * @see org.objectweb.fractal.koch.control.interceptor.LifeCycleInterceptorMixin#addFcInterceptor(org.objectweb.fractal.julia.ComponentInterface,org.objectweb.fractal.julia.Interceptor)
     */
    public void addFcInterceptor(ComponentInterface itf, Interceptor interceptor) throws IllegalLifeCycleException, IllegalInterceptorException {
        if ((weaveableOptLC) != null) {
            String state = weaveableOptLC.getFcState();
            if (!(LifeCycleController.STOPPED.equals(state))) {
                throw new ChainedIllegalLifeCycleException(null , weaveableOptC , "The component is not stopped");
            } 
        } 
        addFcInterceptor$0(itf ,interceptor);
    }
    
    /** 
     * Appends the specified interceptor at the end of the list of already

     * existing interceptors for the specified Fractal interface.

     * 

     * @param itf          the Fractal interface

     * @param interceptor  the interceptor

     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#addFcInterceptor(org.objectweb.fractal.julia.ComponentInterface,org.objectweb.fractal.julia.Interceptor)
     */
    private void addFcInterceptor$0(ComponentInterface itf, Interceptor interceptor) {
        Object last = null;
        Object next = itf.getFcItfImpl();
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            last = next;
            next = i.getFcItfDelegate();
        }
        if (last == null) {
            Object content = itf.getFcItfImpl();
            interceptor.setFcItfDelegate(content);
            itf.setFcItfImpl(interceptor);
        } else {
            Interceptor i = ((Interceptor)(last));
            Object content = i.getFcItfDelegate();
            interceptor.setFcItfDelegate(content);
            i.setFcItfDelegate(interceptor);
        }
        itf.updateFcState();
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptLC = ((LifeCycleController)(ic.getOptionalInterface("lifecycle-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$2(ic);
    }
    
    /** 
     * Checks that the component is stopped and then calls the overriden method.

     * 

     * @param itf          the Fractal interface

     * @param interceptor  the interceptor

     * @return             true if the list contained the specified interceptor

     * 

     * @throws IllegalLifeCycleException if this component has a {@link

     *      LifeCycleController} interface, but it is not in an appropriate

     *      state to perform this operation.

     * @see org.objectweb.fractal.koch.control.interceptor.LifeCycleInterceptorMixin#removeFcInterceptor(org.objectweb.fractal.julia.ComponentInterface,org.objectweb.fractal.julia.Interceptor)
     */
    public boolean removeFcInterceptor(ComponentInterface itf, Interceptor interceptor) throws IllegalLifeCycleException, IllegalInterceptorException {
        if ((weaveableOptLC) != null) {
            String state = weaveableOptLC.getFcState();
            if (!(LifeCycleController.STOPPED.equals(state))) {
                throw new ChainedIllegalLifeCycleException(null , weaveableOptC , "The component is not stopped");
            } 
        } 
        return removeFcInterceptor$0(itf ,interceptor);
    }
    
    /** 
     * The {@link Controller#initFcController initFcController} method overriden
     * by this mixin.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     */
    private void initFcController$3(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * Returns the array of interceptors associated to the specified Fractal

     * interface.

     * 

     * @param itf  the Fractal interface

     * @return     the array of interceptors

     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#getFcInterceptors(org.objectweb.fractal.julia.ComponentInterface)
     */
    public Interceptor[] getFcInterceptors(ComponentInterface itf) {
        Object next = itf.getFcItfImpl();
        int size = 0;
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            next = i.getFcItfDelegate();
            size++;
        }
        Interceptor[] result = new Interceptor[size];
        next = itf.getFcItfImpl();
        size = 0;
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            result[size] = i;
            next = i.getFcItfDelegate();
            size++;
        }
        return result;
    }
    
    /** 
     * The {@link InterceptorController#addFcInterceptor addFcInterceptor} method

     * overriden by this mixin.

     *

     * @param itf          the Fractal interface

     * @param interceptor  the interceptor

     * 

     * @throws IllegalLifeCycleException if this component has a {@link

     *      LifeCycleController} interface, but it is not in an appropriate

     *      state to perform this operation.

     */
    private void addFcInterceptor$1(ComponentInterface itf, Interceptor interceptor) throws IllegalLifeCycleException, IllegalInterceptorException {
    }
    
    /** 
     * Removes the specified interceptor from the list of already existing

     * interceptors for the specified Fractal interface.

     * 

     * @param itf          the Fractal interface

     * @param interceptor  the interceptor

     * @return             true if the list contained the specified interceptor

     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#removeFcInterceptor(org.objectweb.fractal.julia.ComponentInterface,org.objectweb.fractal.julia.Interceptor)
     */
    private boolean removeFcInterceptor$0(ComponentInterface itf, Interceptor interceptor) {
        Object previous = null;
        Object next = itf.getFcItfImpl();
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            if (next == interceptor) {
                Object nextnext = i.getFcItfDelegate();
                if (previous == null) {
                    itf.setFcItfImpl(nextnext);
                } else {
                    Interceptor p = ((Interceptor)(previous));
                    p.setFcItfDelegate(nextnext);
                }
                itf.updateFcState();
                return true;
            } 
            previous = next;
            next = i.getFcItfDelegate();
        }
        return false;
    }
    
    /** 
     * The {@link InterceptorController#removeFcInterceptor removeFcInterceptor}

     * method overriden by this mixin.

     * 

     * @param itf          the Fractal interface

     * @param interceptor  the interceptor

     * @return             true if the list contained the specified interceptor

     * 

     * @throws IllegalLifeCycleException if this component has a {@link

     *      LifeCycleController} interface, but it is not in an appropriate

     *      state to perform this operation.

     */
    private boolean removeFcInterceptor$1(ComponentInterface itf, Interceptor interceptor) throws IllegalLifeCycleException, IllegalInterceptorException {
        return false;
    }
    
    /** 
     * @param interceptors

     *      A stringified representation of a Julia

     *      {@link org.objectweb.fractal.julia.loader.Tree} structure describing

     *      the interceptor class generators associated with this control

     *      membrane.

     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#setInterceptors(java.lang.String)
     */
    public void setInterceptors(String interceptors) {
        this.interceptors = interceptors;
    }
    
    /** 
     * @return

     *      A stringified representation of a Julia

     *      {@link org.objectweb.fractal.julia.loader.Tree} structure describing

     *      the interceptor class generators associated with this control

     *      membrane.

     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#getInterceptors()
     */
    public String getInterceptors() {
        return interceptors;
    }
    
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#interceptors
     */
    private String interceptors = "";
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.adl.juliac.spoon.MixinClassGenerator juliac.generated.InterceptorControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin org.objectweb.fractal.koch.control.interceptor.LifeCycleInterceptorMixin)";
    }
    
}

