package mySweetFactory.audit;



import javax.realtime.WaitFreeWriteQueue;

import mySweetFactory.IMain;


import util.ContextChecker;

public class AuditImpl extends Thread implements IAudit, IMain {

	//queue - will be generated
	private WaitFreeWriteQueue iAudit;
	private volatile boolean stop = false; 
	
	
	/**
	 * Constant representing working in the heap.
	 */
	public static final int HEAP_CONTEXT = 1;

	/**
	 * Constant representing working on a java.lang.Thread
	 */
	public static final int SE_THREAD = 8;
	
	
	
	
	
	/**
	 * 
	 * 
	 * 
	 * @param audit
	 * @param measurementManager
	 */
	public AuditImpl() {
		super();
		//iAudit = audit;
		
	}
	
	public void initialize(WaitFreeWriteQueue queue) {
		iAudit = queue;
	}



  /**
   * 
   * 
   * 
   * 
   */
	public void log(String measurement) {
		
		ContextChecker.checkContext(HEAP_CONTEXT + SE_THREAD);
		
		System.out.println("[Audit] Logging the measurement: " + measurement);
		
		//iMeasurementManager.returnMeasurement(measurement);
		
	}

	
	/**
	 *  must be generated
	 */
	public void run() {
		
		ContextChecker.checkContext(HEAP_CONTEXT + SE_THREAD);
		
		try {
			//Measurement measurement = (Measurement) iAudit.read();
 		  String measurement = (String) iAudit.read();
			
			//while (!stop) {
				//log(measurement);
				//measurement = (Measurement) iAudit.read();
			//}
		
 		  System.out.println("[Audit]" + measurement);
 		  
		
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
	}


  /**
   * Launching the Active component
   */
	public void main(String[] args) {
		this.start();
		
	}
	
	
	
	
}
