package mySweetFactory.bootstrap;

import java.util.ArrayList;
import java.util.List;

import javax.realtime.HeapMemory;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;



public class Bootstrapper implements Runnable, BindingController {

	Runnable iProductionLineRunnable;
	Runnable iMonitoringSystemRunnable;
	Runnable iAuditRunnable;
	
	public void run() {
		
		//System.out.println("ERROR...first create realtime bootstrapping thread... - try to use util package...");

		//iProductionLineRunnable.start();
		//iMonitoringSystemRunnable.start();
		
		Thread th = new Thread(iAuditRunnable);
		
		util.Bootstrapper.runInArea(HeapMemory.instance(), iProductionLineRunnable);
		
		util.Bootstrapper.runInArea(HeapMemory.instance(), iMonitoringSystemRunnable);
		
		th.start();
		
		
	}

	public void bindFc(String clientItfName, Object serverItf) throws NoSuchInterfaceException, IllegalBindingException {
        if (clientItfName.equals("iProductionLineRunnable")) {
            if (!(Runnable.class.isAssignableFrom(serverItf.getClass()))) {
                throw new IllegalBindingException(((("server interfaces connected to " + clientItfName) + " must be instances of ") + (Runnable.class.getName())));
            } 
            iProductionLineRunnable = ((Runnable)(serverItf));
            return ;
        } 

        if (clientItfName.equals("iMonitoringSystemRunnable")) {
            if (!(Runnable.class.isAssignableFrom(serverItf.getClass()))) {
                throw new IllegalBindingException(((("server interfaces connected to " + clientItfName) + " must be instances of ") + (Runnable.class.getName())));
            } 
            iMonitoringSystemRunnable = ((Runnable)(serverItf));
            return ;
        } 
        
        if (clientItfName.equals("iAuditRunnable")) {
          if (!(Runnable.class.isAssignableFrom(serverItf.getClass()))) {
              throw new IllegalBindingException(((("server interfaces connected to " + clientItfName) + " must be instances of ") + (Runnable.class.getName())));
          } 
          iAuditRunnable = ((Runnable)(serverItf));
          return ;
      } 
        
        
        throw new NoSuchInterfaceException((("Client interface \'" + clientItfName) + "\' is undefined."));
    }
    
    public String[] listFc() {
        List __interfaces__ = new ArrayList();
        __interfaces__.add("iProductionLineRunnable");
        __interfaces__.add("iMonitoringSystemRunnable");
        __interfaces__.add("iAuditRunnable");
        return ((String[])(__interfaces__.toArray(new String[]{  })));
    }
    
    public Object lookupFc(String clientItfName) throws NoSuchInterfaceException {
        if (clientItfName.equals("iProductionLineRunnable")) {
            return iProductionLineRunnable;
        } 
        if (clientItfName.equals("iMonitoringSystemRunnable")) {
            return iMonitoringSystemRunnable;
        }
        if (clientItfName.equals("iAuditRunnable")) {
          return iAuditRunnable;
      } 
        throw new NoSuchInterfaceException((("Client interface \'" + clientItfName) + "\' is undefined."));
    }
    
    public void unbindFc(String clientItfName) throws NoSuchInterfaceException {
        if (clientItfName.equals("iMonitoringSystemRunnable")) {
        	iMonitoringSystemRunnable = null;
            return ;
        } 
        
        if (clientItfName.equals("iProductionLineRunnable")) {
        	iProductionLineRunnable = null;
            return ;
        } 
        
        if (clientItfName.equals("iAuditRunnable")) {
        	iAuditRunnable = null;
            return ;
        } 
        
        throw new NoSuchInterfaceException((("Client interface \'" + clientItfName) + "\' is undefined."));
    }

	
	
	
}
