package interceptor;

import javax.realtime.ImmortalMemory;
import javax.realtime.NoHeapRealtimeThread;
import javax.realtime.RealtimeThread;
import javax.realtime.WaitFreeWriteQueue;

import mySweetFactory.IMonitor;
import mySweetFactory.measurement.Measurement;

import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.julia.InitializationContext;

class InterceptorPush implements Runnable {

	private IMonitor _impl;
	private WaitFreeWriteQueue _queue;

	private boolean quit = false;

	public InterceptorPush(WaitFreeWriteQueue queue, IMonitor iMonitor) {
		_impl = iMonitor;
		_queue = queue;

	}

	public void run() {
		while (!quit) {
			try {
				
				System.out.println("[MyInterceptor] Reading the queue...");
				Measurement measurement = (Measurement) _queue.read();
				
				System.out.println("[MyInterceptor] Sending the measurement...");
				_impl.processMeasurement(measurement);

			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}

	}

}

public class MyInterceptor implements mySweetFactory.IMonitor,
		org.objectweb.fractal.julia.Interceptor {

	private mySweetFactory.IMonitor _impl;
    private WaitFreeWriteQueue _queue;
    private NoHeapRealtimeThread nhrt;
    
	public MyInterceptor() {
       
	}

	public MyInterceptor(Object obj) {
		setFcItfDelegate(obj);
	}

	public MyInterceptor(WaitFreeWriteQueue _queue, IMonitor iMonitor) {
		setFcItfDelegate(iMonitor);
		
		InterceptorPush push = new InterceptorPush(_queue,iMonitor);
		nhrt = new NoHeapRealtimeThread(null, null, null,
				ImmortalMemory.instance(), // Start the thread in immortal
				null, push);
		
		
		
	}
	
	public void start() {
		nhrt.start();
		
		System.out.println("[MyInterceptor] Interceptor Started!!!");
		
	}
	
	
	public Object clone() {
		MyInterceptor clone = new MyInterceptor(getFcItfDelegate());
		return clone;
	}

	public Object getFcItfDelegate() {
		return _impl;
	}

	public void setFcItfDelegate(Object obj) {
		_impl = (mySweetFactory.IMonitor) obj;
	}

	public void initFcController(InitializationContext ic)
			throws InstantiationException {
	}

	
	public void processMeasurement(Measurement measurement) {
		// TODO Auto-generated method stub
		
	}

}
