/*
 * Generated by org.objectweb.fractal.adl.juliac.adl.DefaultCompFactorySourceCodeGenerator on: Mon Apr 14 16:52:37 CEST 2008
 */

package mySweetFactory;



import javax.realtime.ImmortalMemory;
import javax.realtime.LTMemory;
import javax.realtime.MemoryArea;
import javax.realtime.RealtimeThread;
import javax.realtime.WaitFreeWriteQueue;

import mySweetFactory.measurement.MeasurementManager;
import mySweetFactory.util.ContextChecker;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.util.Fractal;


/**
 * 
 * 
 * 
 * This class will be executed by a RealTimeThread. 
 * 
 * It contains logic for instatiation of all the components.
 * 
 * 
 * 
 * 
 * @author Ales
 *
 */
class ImmortalAllocation implements Runnable {

	public Component productionLine;
	public Exception exception = null;

	/**
	 * just some logic for printing on Console when being in immortal - since its not so trivial...
	 */
	final LTMemory scopedA = new LTMemory(8 * 1024);
	Runnable runTh = new Runnable() {
		public void run() {
			//System.out.println("Mem Consumed " + scopedA.memoryConsumed());
			//System.out.println("immortal memory consumed " + ImmortalMemory.instance().memoryConsumed()  );
			System.out.println("Mem Consumed " + scopedA.memoryConsumed());
			System.out.println("immortal memory consumed "
					+ ImmortalMemory.instance().memoryConsumed());
		}
	};

	private void memConsumed() {
		scopedA.enter(runTh);
	}

	public void run() {

		try {

			memConsumed();

			//checking that we are operating in immortal memory
			ContextChecker.checkContext(ContextChecker.IMMORTAL_CONTEXT);
			ContextChecker.checkContext(ContextChecker.RT_THREAD);

			
			int SIZE = 10;
			WaitFreeWriteQueue queue = new WaitFreeWriteQueue(SIZE, ImmortalMemory
					.instance());

			WaitFreeWriteQueue heapQueue = new WaitFreeWriteQueue(SIZE,
					ImmortalMemory.instance());

			MeasurementManager measurementManager = new MeasurementManager();
			
			
			
			
			
			
			Component C0 = new mySweetFactory.bootstrap.BootstrapperFCprimitiveFCedaa3a69()
					.newFcInstance();
			Fractal.getNameController(C0).setFcName("BootStrapper");

			Component C1 = new mySweetFactory.ProductionLineImplFCsoleilPrimitiveFCf12ee574(
					queue, measurementManager).newFcInstance();
			Fractal.getNameController(C1).setFcName("ProductionLine");

			Component C2 = new mySweetFactory.MonitoringSystemImplFCsoleilPrimitiveServerFC7f02226f(
					queue, heapQueue, measurementManager).newFcInstance();
			Fractal.getNameController(C2).setFcName("MonitoringSystem");

			Component C3 = new mySweetFactory.ConsoleImplFCscopePrimitiveFC8c62a555()
					.newFcInstance();
			Fractal.getNameController(C3).setFcName("Console");
			Fractal.getLifeCycleController(C3).startFc();

			Component C4 = new mySweetFactory.audit.AuditImplFCheapPrimitiveFCcdbf0637(
					heapQueue).newFcInstance();
			Fractal.getNameController(C4).setFcName("Audit");
			Fractal.getLifeCycleController(C4).startFc();

			
			
			/**
			 * Ales: following code generated by juliac
			 */
			Component C5 = new juliac.generated.compositeFCf938cfee().newFcInstance();
			Fractal.getNameController(C5).setFcName("mySweetFactory.MySweetFactory");
			Fractal.getContentController(C5).addFcSubComponent(C0);
			Fractal.getContentController(C5).addFcSubComponent(C1);
			Fractal.getContentController(C5).addFcSubComponent(C2);
			Fractal.getContentController(C5).addFcSubComponent(C3);
			Fractal.getContentController(C5).addFcSubComponent(C4);
			Fractal.getBindingController(C5).bindFc("r", C0.getFcInterface("r"));
			Fractal.getBindingController(C1).bindFc("iMonitor",
					C2.getFcInterface("iMonitor"));
			Fractal.getBindingController(C2).bindFc("iConsole",
					C3.getFcInterface("iConsole"));
			Fractal.getBindingController(C2).bindFc("iAudit",
					C4.getFcInterface("iAudit"));
			Fractal.getBindingController(C0).bindFc("iProductionLineRunnable",
					C1.getFcInterface("iProductionLineRunnable"));
			Fractal.getBindingController(C0).bindFc("iMonitoringSystemRunnable",
					C2.getFcInterface("iMonitoringSystemRunnable"));
			Fractal.getBindingController(C0).bindFc("iAuditRunnable",
					C4.getFcInterface("iAuditRunnable"));
			Fractal.getLifeCycleController(C0).startFc();
			Fractal.getLifeCycleController(C1).startFc();
			Fractal.getLifeCycleController(C2).startFc();
			Fractal.getLifeCycleController(C5).startFc();
			// --------------------------------------------------

			memConsumed();

			productionLine = C5;

		} catch (Exception e) {
			//throw new org.objectweb.fractal.julia.factory.ChainedInstantiationException(e,null,e.getClass().getName()+": "+e.getMessage());
			exception = e;

		}
	}
}




/**
 * 
 * juliac generated
 *
 *
 */
public class MySweetFactory implements
		org.objectweb.fractal.api.factory.Factory {

	public Object getFcContentDesc() {
		throw new java.lang.UnsupportedOperationException();
	}

	public Object getFcControllerDesc() {
		throw new java.lang.UnsupportedOperationException();
	}

	public Component newFcInstance()
			throws org.objectweb.fractal.api.factory.InstantiationException {

		
		/**
		 * 
		 * Ales
		 * 
		 */
		// instantiating the immortal component
		Component sweetFactory = allocInImmortal();

		return sweetFactory;

		/*
		try {
		  // --------------------------------------------------
		Component C0 = new mySweetFactory.bootstrap.BootstrapperFCprimitiveFCedaa3a69().newFcInstance();
		Fractal.getNameController(C0).setFcName("BootStrapper");
		Component C1 = new mySweetFactory.ProductionLineImplFCsoleilPrimitiveFCf12ee574().newFcInstance();
		Fractal.getNameController(C1).setFcName("ProductionLine");
		Component C2 = new mySweetFactory.MonitoringSystemImplFCsoleilPrimitiveServerFC7f02226f().newFcInstance();
		Fractal.getNameController(C2).setFcName("MonitoringSystem");
		Component C3 = new mySweetFactory.ConsoleImplFCscopePrimitiveFC8c62a555().newFcInstance();
		Fractal.getNameController(C3).setFcName("Console");
		Fractal.getLifeCycleController(C3).startFc();
		Component C4 = new mySweetFactory.audit.AuditImplFCheapPrimitiveFCcdbf0637().newFcInstance();
		Fractal.getNameController(C4).setFcName("Audit");
		Fractal.getLifeCycleController(C4).startFc();
		Component C5 = new juliac.generated.compositeFCf938cfee().newFcInstance();
		Fractal.getNameController(C5).setFcName("mySweetFactory.MySweetFactory");
		Fractal.getContentController(C5).addFcSubComponent(C0);
		Fractal.getContentController(C5).addFcSubComponent(C1);
		Fractal.getContentController(C5).addFcSubComponent(C2);
		Fractal.getContentController(C5).addFcSubComponent(C3);
		Fractal.getContentController(C5).addFcSubComponent(C4);
		Fractal.getBindingController(C5).bindFc("r", C0.getFcInterface("r"));
		Fractal.getBindingController(C1).bindFc("iMonitor", C2.getFcInterface("iMonitor"));
		Fractal.getBindingController(C2).bindFc("iConsole", C3.getFcInterface("iConsole"));
		Fractal.getBindingController(C2).bindFc("iAudit", C4.getFcInterface("iAudit"));
		Fractal.getBindingController(C0).bindFc("iProductionLineRunnable", C1.getFcInterface("iProductionLineRunnable"));
		Fractal.getBindingController(C0).bindFc("iMonitoringSystemRunnable", C2.getFcInterface("iMonitoringSystemRunnable"));
		Fractal.getBindingController(C0).bindFc("iAuditRunnable", C4.getFcInterface("iAuditRunnable"));
		Fractal.getLifeCycleController(C0).startFc();
		Fractal.getLifeCycleController(C1).startFc();
		Fractal.getLifeCycleController(C2).startFc();
		Fractal.getLifeCycleController(C5).startFc();
		  // --------------------------------------------------
		  return C5;
		}
		catch( Exception e ) {
		  throw new org.objectweb.fractal.julia.factory.ChainedInstantiationException(e,null,e.getClass().getName()+": "+e.getMessage());
		}*/
	}

	/**
	 * Ales
	 * 
	 * 
	 * 
	 * instantiating the immortal component - productionLine
	 * 
	 * 
	 * @return
	 */
	private Component allocInImmortal() {

		// runnable thread containing the logic (instantiation proceedures) that has to be
		// executed in the immortal memory
		ImmortalAllocation immAlloc = new ImmortalAllocation();

		//realtime thread working in immortal memory
		// - this thread do the instantiation - it will execute the immAlloc thread 
		RealtimeThread rt = new RealtimeThread(null, null, null, ImmortalMemory
				.instance(), // Start the thread in immortal
				null, immAlloc);
		// running the instantiation
		rt.start();

		//TODO: waiting until the instantiation will finish - here will be a problem on truly real-time machines
		try {
			RealtimeThread.sleep(2000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block

			e.printStackTrace();
		}
		//System.out.println("Checking the immortal allocation result (should be non null):"+ immAlloc.productionLine);

		if (immAlloc.exception != null) {
			System.out.println("ERROR: exception thrown during intialization.");
			System.out.println("Exception:" + immAlloc.exception.toString() + "    "
					+ immAlloc.exception.getMessage());
			immAlloc.exception.printStackTrace();

			return null;
		}

		if (!(MemoryArea.getMemoryArea(immAlloc.productionLine) instanceof ImmortalMemory)) {
			System.out.println("ERROR: ProductionLine is NOT in immortal.");
			System.out.println("Is in: "
					+ MemoryArea.getMemoryArea(immAlloc.productionLine));
			return immAlloc.productionLine;
		}

		System.out.println("ProductionLine is immortal, instantiation... OK.");
		return immAlloc.productionLine;
	}

	public org.objectweb.fractal.api.Type getFcInstanceType() {
		try {
			// --------------------------------------------------
			org.objectweb.fractal.api.type.ComponentType ct = new org.objectweb.fractal.julia.type.BasicComponentType(
					new org.objectweb.fractal.api.type.InterfaceType[] { new org.objectweb.fractal.julia.type.BasicInterfaceType(
							"r", "java.lang.Runnable", false, false, false), });
			// --------------------------------------------------
			return ct;
		} catch (org.objectweb.fractal.api.factory.InstantiationException e) {
			throw new RuntimeException(e);
		}
	}

}
